unit compases;
// PAR SDL Zelda was created using the PAR SDL Framework
// Created by Paul Robello by examples and demos from but not limited to:
// nehe.gamedev.net, www.delphi-jedi.org, romka.demonews.com, www.nutty.org.
// Most code has been heavily modified for speed and integration.
// PAR SDL Framework is an always changing project that may not be backward
// compatable with other projects.
// Questions, comments, ravs, flames email paulr@cal.net

interface

uses opengl12,parsdlgl;

var ShowCompass : boolean = true;                                               // toggle compass on or off
    compasslist : gluint;                                                       // compiled compass lists
    CurrCompass : longint = 0;                                                  // currently selected compass
    MaxCompass : longint = 3;                                                   // total number of compasses

procedure doCompass0(dir : longint);
procedure doCompass1(dir : longint);
procedure doCompass2(dir : longint);

implementation

const compasRosePoints : array[0..8,0..2] of GLFloat = ((0,0.05,0),(-1,0,0),(-0.1,0,0.1),(0,0,1),(0.1,0,0.1),(1,0,0),(0.1,0,-0.1),(0,0,-1),(-0.1,0,-0.1));

procedure doCompass2(dir : longint);
var q1 : PGLUQuadric;
begin
   glEnable(GL_BLEND);
   glDisable(GL_DEPTH_TEST);
   glDisable(GL_LIGHTING);
   glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA);
   glEnable(GL_TEXTURE_2D);
   glDisable(GL_FOG);
   q1:=gluNewQuadric();
   gluQuadricNormals(q1, GLU_SMOOTH);	                                        // Create Smooth Normals
   gluQuadricTexture(q1, true);                                       	        // Create Texture Coords
   glPushMatrix();
      glLoadIdentity;
      glrotatef(-90,1,0,0);
      materials.SetMaterial('compass1');
      gltranslatef(0.45,2,-0.5);
      glrotatef(-dir-120,0,0,1);
      gluCylinder(q1,0.15,0.15,0.15,16,2);
   glPopMatrix();								// Restore The Old Projection Matrix
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_LIGHTING);
end;

procedure doCompass1;
var q1 : PGLUQuadric;
begin
   glDisable(GL_FOG);
   glDisable(GL_CULL_FACE);                                                     // You don't need those in 2D.


   glEnable(GL_BLEND);
   glDisable(GL_DEPTH_TEST);

   glEnable(GL_LIGHTING);
   glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA);
   q1:=gluNewQuadric();
   gluQuadricNormals(q1, GLU_SMOOTH);                                           // Create Smooth Normals
   gluQuadricTexture(q1, true);                                     	        // Create Texture Coords


   glPushMatrix();
      glLoadIdentity;
      SetLight(@Light0);
      glrotatef(-90,1,0,0);

      materials.SetMaterial('compass3');                                        // compas dial
      gltranslatef(0.54,2,0.4);
      glrotatef(45,1,0,0);
      glPushMatrix();
         glrotatef(dir-90,0,0,1);
         gluDisk(q1,0,0.15,16,1);
      glPopMatrix();

      glpushmatrix();                                                           // compas needle
         glDisable(GL_LIGHTING);
         glDisable(GL_Texture_2d);
         glrotatef(-90,1,0,0);
         glcolor4f(1,0,0,1);
         gluCylinder(q1,0.01,0.0,0.15,3,2);
      glpopmatrix();

      glEnable(GL_LIGHTING);                                                    // body of compas
      gltranslatef(0,0,-0.005);
      glcolor4f(0,0,1,1);
      glDisable(GL_Texture_2d);
      gluCylinder(q1,0.152,0.152,0.05,16,2);

      glEnable(GL_Texture_2d);
      glEnable(GL_DEPTH_TEST);
      glEnable(GL_LIGHTING);
   glPopMatrix();
end;

procedure doCompass0(dir : longint);
var i : longint;
    q1 : PGLUQuadric;
    size : glfloat;
begin
   glDisable(GL_LIGHTING);
   glDisable(GL_FOG);
   glDisable(GL_CULL_FACE);                                                     // You don't need those in 2D.
   glPushMatrix();
   glLoadIdentity;
   gldisable(GL_DEPTH_TEST);

   if compasslist<1 then begin
      q1:=gluNewQuadric();
      gluQuadricNormals(q1, GLU_SMOOTH);                                        // Create Smooth Normals
      gluQuadricTexture(q1, true);                                     	        // Create Texture Coords

      compasslist:=glGenLists(2);
      glNewList(compasslist,GL_COMPILE);

         glDisable(GL_Texture_2d);

         glrotatef(-90,1,0,0);
         glscalef(0.1,0.1,0.1);
         glBegin(GL_TRIANGLES);
         for i:=1 to 7 do begin                                                 // compas needle (compas rose style)
            case i of
               2 :  glcolor4f(1,0,0,1);
               3 :  glcolor4f(0.5,0,0,1);
               6,4,1:  glcolor4f(0.8,0.8,0.8,1);
               5,7:  glcolor4f(0.65,0.65,0.65,1);
            end;
            glvertex3f(compasRosePoints[0,  0],compasRosePoints[0,  1],compasRosePoints[0,  2]);
            glvertex3f(compasRosePoints[i,  0],compasRosePoints[i,  1],compasRosePoints[i,  2]);
            glvertex3f(compasRosePoints[i+1,0],compasRosePoints[i+1,1],compasRosePoints[i+1,2]);
         end;
         glvertex3f(compasRosePoints[0,0],compasRosePoints[0,1],compasRosePoints[0,2]);
         glvertex3f(compasRosePoints[8,0],compasRosePoints[8,1],compasRosePoints[8,2]);
         glvertex3f(compasRosePoints[1,0],compasRosePoints[1,1],compasRosePoints[1,2]);

         glEnd;
      glEndList;

      glNewList(compasslist+1,GL_COMPILE);
       glrotatef(90,1,0,0);
         size:=0.12;
         materials.SetMaterial('compass4');
         glEnable(GL_Texture_2d);
         glEnable(GL_Blend);
         glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

         glBegin(GL_QUADS);
            glNormal3f (0.0, -size, 0.0);
            glTexCoord2f(0,0);
            glVertex3f (-size, -size, -size);
            glTexCoord2f(1,0);
            glVertex3f (size, -size, -size);
            glTexCoord2f(1,1);
            glVertex3f (size, -size, size);
            glTexCoord2f(0,1);
            glVertex3f (-size, -size, size);
       glEnd;

      glEndList;


   end;

   glrotatef(-90,1,0,0);
   gltranslatef(0.35,1.5,-0.2);
   glrotatef(-70,1,0,0);
   glCallList(compasslist+1);
   gltranslatef(0.01,-0.07,0);
   glrotatef(-dir+90,0,0,1);
   glCallList(compasslist);

   glPopMatrix;
end;

end.
