unit linkdef;
// PAR SDL Zelda was created using the PAR SDL Framework
// Created by Paul Robello by examples and demos from but not limited to:
// nehe.gamedev.net, www.delphi-jedi.org, romka.demonews.com, www.nutty.org.
// Most code has been heavily modified for speed and integration.
// PAR SDL Framework is an always changing project that may not be backward
// compatable with other projects.
// Questions, comments, ravs, flames email paulr@cal.net

interface

uses opengl12,parsdlgl;

const lstDead=0;
      lstDying=1;
      lstStoped=2;
      lstNormal=3;
      lstAttack=4;

type tlink= class(tobject)
   public
    lx,ly : glfloat;                                                            // Link X, Y Position
    nlx,nly : longint;                                                          // Next Link X, Y Position for collsion detection
    ilx,ily : glint;                                                            // integer values for lx,ly
    oldLx,oldLy : glfloat;               					// Old Link X, Y Positions
    olddir,dir,viewbob: longint;
    life,maxlife: byte;                                                         // hearts  odd numbers are half
    sword,                                                                      // Sword 0=none, 1=normal, 2=white, 3=master
    shield,                                                                     // Shield 0=none, 1=small shield, 2=large shield
    bombs,maxBombs,
    keys,
    candle,                                                                     // 0=none, 1=blue candle, 2=red candle
    ring,                                                                       // 0=none, 1=blue, 2=red
    rupies,                                                                     // money   5=blue 1=red
    bow,                                                                        // 0=none, 1=normal, 2=silver
    wand,                                                                       // 0=none, 1=have
    book,                                                                       // 0=none, 1=have
    bridge,                                                                     // 0=none, 1=have
    raft,                                                                       // 0=none, 1=have
    boomerang,                                                                  // 0=none, 1=normal, 2=blue
    medicine,                                                                   // 0=none, 1=blue(half), 2=red(full)
    meat,                                                                       // 0=none, 1=have
    note,                                                                       // 0=none, 1=have
    bracelet,                                                                   // 0=none, 1=have
    flute : byte;                                                               // 0=none, 1=have
    state : byte;
    anim  : longint;
    constructor create();
end;
plink = ^tlink;

var link : Tlink;

procedure DrawHud;

implementation

constructor TLink.create();
begin
   inherited create;
      dir:=90;                                                                  // Link start look  90 = north
      oldDir:=dir;

      lx:=116;          							// 116    Link map Position
      ly:=5;                                                                    // 5
      nlx:=trunc(lx);
      nly:=trunc(ly);
      ilx:=trunc(lx);                                                           // integer link pos
      ily:=trunc(ly);
      oldLx:=lx;                                                                // old link pos
      oldLy:=ly;
      viewbob:=0;                                                               // Link start walk bounce

      maxlife:=6;                                                               // hearts odd numbers are half
      life:=maxlife-1;                                                          // Start full life

      rupies:=0;                                                                // money   5=blue 1=red
      keys:=0;                                                                  // > 50 = magic key
      maxbombs:=3;
      bombs:=0;
      sword:=0;                                                                 // 0=none, 1=wood, 2=white, 3=master
      shield:=0;                                                                // Shield 0=none, 1=small shield, 2=large shield
      boomerang:=0;                                                             // 0=none, 1=normal, 2=blue
      bow:=0;                                                                   // 0=none, 1=normal, 2=silver
      note:=0;                                                                  // 0=none, 1=have
      medicine:=0;                                                              // 0=none, 1=blue(half), 2=red(full)
      ring:=0;                                                                  // 0=none, 1=blue, 2=red
      candle:=0;                                                                // 0=none, 1=blue candle, 2=red candle
      flute:=0;                                                                 // 0=none, 1=have
      wand:=0;                                                                  // 0=none, 1=have
      book:=0;                                                                  // 0=none, 1=have
      bridge:=0;                                                                // 0=none, 1=have
      raft:=0;                                                                  // 0=none, 1=have
      meat:=0;                                                                  // 0=none, 1=have
      bracelet:=0;                                                              // 0=none, 1=have

      state:=lstNormal;
      anim  := 0;
end;


procedure DrawHud;
var i,c : longint;
    size : glfloat;
begin
   size:=0.025;
   glLoadIdentity();
   gltranslatef(-0.6,0.5,-2);
   glDisable(GL_Lighting);
   glDisable(GL_Depth_Test);
   gldepthmask(false);
   glDisable(GL_FOG);
   glEnable(GL_Texture_2d);
   glEnable(GL_Blend);
   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   Materials.SetMaterial('heart1');

   for i:=1 to (link.life div 2) do begin
      glBegin(GL_QUADS);
         glTexCoord2f(0, 0);  glVertex3f(-size, -size, 0);                      // Texture / Vertex Coord (Bottom Left)}
         glTexCoord2f(1, 0);  glVertex3f( size, -size, 0);                      // Texutre / Vertex Coord (Bottom Right)
         glTexCoord2f(1, 1);  glVertex3f( size,  size, 0);                      // Texture / Vertex Coord (Top Right)
         glTexCoord2f(0, 1);  glVertex3f(-size,  size, 0);                      // Texture / Vertex Coord (Top Left)
      glend;
      gltranslatef(0.05,0,0);
   end;
   c:=(link.life mod 2);
   if c=1 then begin
      Materials.SetMaterial('heart2');
      glBegin(GL_QUADS);
         glTexCoord2f(0, 0);  glVertex3f(-size, -size, 0);                         // Texture / Vertex Coord (Bottom Left)}
         glTexCoord2f(1, 0);  glVertex3f( size, -size, 0);                         // Texutre / Vertex Coord (Bottom Right)
         glTexCoord2f(1, 1);  glVertex3f( size,  size, 0);                         // Texture / Vertex Coord (Top Right)
         glTexCoord2f(0, 1);  glVertex3f(-size,  size, 0);                         // Texture / Vertex Coord (Top Left)
      glend;
      gltranslatef(0.05,0,0);
   end;
   if (link.life div 2) < ((link.maxlife-c) div 2) then begin
      Materials.SetMaterial('heart3');
      for i:=1 to (link.maxlife div 2)-(link.life div 2) do begin
         glBegin(GL_QUADS);
            glTexCoord2f(0, 0);  glVertex3f(-size, -size, 0);                         // Texture / Vertex Coord (Bottom Left)}
            glTexCoord2f(1, 0);  glVertex3f( size, -size, 0);                         // Texutre / Vertex Coord (Bottom Right)
            glTexCoord2f(1, 1);  glVertex3f( size,  size, 0);                         // Texture / Vertex Coord (Top Right)
            glTexCoord2f(0, 1);  glVertex3f(-size,  size, 0);                         // Texture / Vertex Coord (Top Left)
         glend;
         gltranslatef(0.05,0,0);
      end;
   end;

   gldepthmask(true);
end;

end.
